/*                               CWIMAGE.C                               */

#include <stdio.h>
#include "cwrx.h"

/*
 * Image collects from incoming cw -signal a bitmap of a character. 
 * Most significant 1 -bit is allways a beginflag of an image.
 * The rest of the image is coded as: 1 means a 'dah' and 0 means a 'dit'.
 */

int image(int port) {
  int i,cwimg;
  static int count=200;                    /* Length of a 'dit' */
  static int space=0;                      /* A flag for making space
                                              between two words  */

                                           /* If longer pause than 4 'dits'
					      then its end of the word */
  for (i=0;KEYUP && (i<4*count);i++);
  if ((i>=3*count) && space) {
    space = 0;                             /* No more spaces than 1    */
    putchar(' ');
  }

  cwimg = 1;                               /* Initialize image         */
  while KEYUP;                             /* Wait for keydown sequence */

/*
 * This is the main loop for collecting an image
 */

  for (;;) {
    sound();                               /* Make some noise          */
    cwimg <<= 1;                           /* Make room for a new bit 
					      of the image             */
    for (i=0;KEYDOWN;i++);                 /* Wait for release of the key */
    nosound();                             /* Stop that noise          */
                                           
/* 
 * Now it's time to make a decision if a bit, just got, is going to be 1 or 0 
 * variable 'i' is proportional to the lenth of a keydown sequence just got.   
 */

    if (i>2*count) {                       /* If lengthier than 2 'dit's */
      cwimg |= 1;                          /* It really is a 'dah'       */
      i /= 3;                              /* So manipulate cwimg 
					      accordingly                */
    }

/* 
 * Variable 'count' (length of a 'dit') needs updating to make a program
 * capable to adaptate to incoming signal.                               
 */

    count = (i+count) / 2;                 /* Anyhow make 'count' to an
					      average of the new and the old
                                              length of a 'dit'          */

/* 
 * Now, wait for a new keydown sequence start before time of 2 'dits' has
 * elapsed. If so, continue collecting of an image. Else the image is ready,
 * return it for further processing.                                     
 */
 
    for (i=0;KEYUP && (i<2*count);i++);
    if (i>= 2*count) break;

    else count = (i+count) /2;             /* Update 'count' with length
					      of a space                 */
  }
  space = 1;                               /* A space between words is
					      possible after a charcter  */
  return cwimg;
}
    






