/*                         CWRX.H                                     */

#define TIMER 0x42
#define IFACE 0x61
#define KEYUP (key(port) == UP)
#define KEYDOWN (key(port) == DOWN)

/*
 * Put the tone of 440Hz out of the PC speaker.
 */

void sound(); 

/*
 * Cut out the tone output from speaker.
 */

void nosound();

#define UP 1
#define DOWN 0

/*
 * Investigating the status of the key
 * Returns UP if key not depressed, else DOWN.
 */

int key(int port);

/*
 * Pull up the pin into which the key is connected.
 * This is to avoid hum problems. There must be abt. 1k resistor
 * connected between pins 9 and 12 of the printer port. In addition
 * to this, abt. .1 uF condensator between pins 12 and 25 must be
 * in place.
 */

void pullup(int port);

/*
 * This function finds a character corresponding to its argument image.
 * Returns 0 if not found.
 */

char merkki(int image);


/*
 * Image is the function which does most of the dirty work in this
 * program. It collects a bit pattern for a character to print into screen.
 */

int image(int port);

/*
 * Function to put some help into users screen.
 */

void help(char *s);







