/*                          CWSOUND.C                                    */

#include <unistd.h>
#include <asm/io.h>
#include "cwrx.h"

/*
 * Let's make some noise.
 * Abt. 440 Hz tone out of the PC speaker.
 */

void sound() {
  unsigned char al;
                                  /* Allow access to speaker gate
				     and TIMER chip registers */
  ioperm(IFACE,1,1);
  ioperm(TIMER,2,1);
                                  /* Open the speaker gate */
  al = inb(IFACE);
  al |= 3;
  outb(al,IFACE);
                                  /* Initialize TIMER chip for
				     440 Hz tone               */
  outb(0xb6,TIMER+1);
  outb(0x91,TIMER);
  outb(0x0a,TIMER);
                                  /* Prohibit access to chips
				     involved                  */
  ioperm(IFACE,1,0);
  ioperm(TIMER,2,0);
}

/*
 * Turn the sound off
 */

void nosound() {
  unsigned char al;
                                  /* Allow io-port access */
  ioperm(IFACE,1,1);
                                  /* Turn the sound gate off */
  al = inb(IFACE);
  al &= 0xfc;
  outb(al,IFACE);
                                  /* Prohibit access to port */ 
  ioperm(IFACE,1,0);
}
  

    




